#include <stdlib.h>
#include <string.h>
#include "list.h"

list_t *list_create()
{
    list_t *tmp;
    tmp = malloc(sizeof(list_t));
    if (tmp == NULL)
        return NULL;

    tmp->head = NULL;
    tmp->tail = NULL;

    tmp->size = 0;

    return tmp;
}

int list_add(list_t *l, void *data, size_t size)
{
    list_node_t *n;

    n = malloc(sizeof(list_node_t));
    if (n == NULL)
        return -1;

    n->data = malloc(size);
    if (n->data == NULL){
        free(n);
        return -1;
    }

    memcpy(n->data, data, size);
    n->size = size;
    n->next = NULL;

    if (l->tail == NULL){
        l->tail = l->head = n;
    } else {
        l->tail->next = n;
        l->tail = n;
    }

    l->size++;

    return 0;
}

void list_destroy(list_t *l)
{
    list_node_t *next, *curr;

    if (l == NULL)
        return;

    for(curr = l->head; curr != NULL; curr = next){
        next = curr->next;
        free(curr->data);
        free(curr);
    }

    free(l);
}

